# http://doc.gitlab.com/ce/ci/yaml/README.html
# https://docs.gitlab.com/ce/ci/variables/README.html
# https://docs.gitlab.com/ce/ci/docker/using_docker_build.html#use-docker-in-docker-executor

image: docker:stable

variables:
  # When using dind service we need to instruct docker, to talk with the daemon started inside of the service which is available with a network connection instead of the default /var/run/docker.sock socket.
  DOCKER_HOST: tcp://docker:2375/
  # When using dind (docker-in-docker), it's wise to use the overlayfs driver for improved performance (the kernel module 'overlay' must be loaded).
  DOCKER_DRIVER: overlay2
  # tag naming
  TAG_FINAL: latest
  TAG_PREFIX: ${CI_COMMIT_REF_NAME%master}

services:
  - docker:dind

before_script:
  - echo "${CI_JOB_TOKEN}" | docker login --username gitlab-ci-token --password-stdin "${CI_REGISTRY}"
  - if [[ -n "${DOCKER_USERNAME}" ]]; then echo "${DOCKER_PASSWORD}" | docker login --username "${DOCKER_USERNAME}" --password-stdin docker.io; fi
  - docker info

stages:
  - build
  - release

build:
  stage: build
  script:
    - ./build.sh --build "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --push "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"

release:
  stage: release
  only:
    - master
  script:
    - ./build.sh --pull "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --tag "${CI_REGISTRY_IMAGE}${DOCKER_REPOS:+ ${DOCKER_REPOS}}${DOCKER_USERNAME:+ docker.io/${DOCKER_USERNAME}/${CI_PROJECT_NAME#docker-}}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --push "${CI_REGISTRY_IMAGE}${DOCKER_REPOS:+ ${DOCKER_REPOS}}${DOCKER_USERNAME:+ docker.io/${DOCKER_USERNAME}/${CI_PROJECT_NAME#docker-}}" "${TAG_FINAL}" "${TAG_PREFIX}"
